/********************************** (C) COPYRIGHT *******************************
* File Name          : main.c
* Author             : WCH
* Version            : V1.0.0
* Date               : 2021/06/06
* Description        : Main program body.
* Copyright (c) 2021 Nanjing Qinheng Microelectronics Co., Ltd.
* SPDX-License-Identifier: Apache-2.0
*******************************************************************************/

/*
 *@Note
 Ƚģʽ̣
 TIM1_CH1(PA8)
*/

#include "debug.h"
void TIM1_CC_IRQHandler(void) __attribute__((interrupt("WCH-Interrupt-fast")));
u32 capture = 0;
u8 flag1 = 0,flag2 = 0,flag3 = 0;//־λ
u16 setcap = 0;
u16 CCR1_dc = 20;
u16 CCR2_dc = 40;
u16 CCR3_dc = 60;
//ʱ910us  72MHz
u16 CCR1_Val = 32768;   //65535/2   455us   2.19KHz
u16 CCR2_Val = 16384;   //65535/4   227.5us 4.39KHz
u16 CCR3_Val = 8192;    //655335/8  113.75us    8.79KHz
////ʱ455us  144MHz
//u16 CCR1_Val = 4001;   //65535/16.38   36KHz  27.77us
//u16 CCR2_Val = 8002;   //65535/8.19   18KHz  55.55us
//u16 CCR3_Val = 16004;    //655335/4.095  9KHz   111.11us
void TIM1_OutCompare_Init( u16 arr, u16 psc)
{
	GPIO_InitTypeDef GPIO_InitStructure={0};
	TIM_OCInitTypeDef TIM_OCInitStructure={0};
	TIM_TimeBaseInitTypeDef TIM_TimeBaseInitStructure={0};
    NVIC_InitTypeDef  NVIC_InitStructure = {0};

	RCC_APB2PeriphClockCmd( RCC_APB2Periph_GPIOA | RCC_APB2Periph_TIM1, ENABLE );

	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_8;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_Init( GPIOA, &GPIO_InitStructure );
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_9;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_Init( GPIOA, &GPIO_InitStructure );
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_10;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_Init( GPIOA, &GPIO_InitStructure );

	TIM_TimeBaseInitStructure.TIM_Period = arr;
	TIM_TimeBaseInitStructure.TIM_Prescaler = psc;
	TIM_TimeBaseInitStructure.TIM_ClockDivision = TIM_CKD_DIV1;
	TIM_TimeBaseInitStructure.TIM_CounterMode = TIM_CounterMode_Up;
	TIM_TimeBaseInit( TIM1, &TIM_TimeBaseInitStructure);

	TIM_OCInitStructure.TIM_OCMode = TIM_OCMode_Toggle;
	TIM_OCInitStructure.TIM_OutputState = TIM_OutputState_Enable;
	TIM_OCInitStructure.TIM_Pulse = CCR1_Val;
	TIM_OCInitStructure.TIM_OCPolarity = TIM_OCPolarity_High;
	TIM_OC1Init( TIM1, &TIM_OCInitStructure );
    TIM_OCInitStructure.TIM_OCMode = TIM_OCMode_Toggle;
    TIM_OCInitStructure.TIM_OutputState = TIM_OutputState_Enable;
    TIM_OCInitStructure.TIM_Pulse = CCR2_Val;
    TIM_OCInitStructure.TIM_OCPolarity = TIM_OCPolarity_High;
    TIM_OC2Init( TIM1, &TIM_OCInitStructure );
    TIM_OCInitStructure.TIM_OCMode = TIM_OCMode_Toggle;
    TIM_OCInitStructure.TIM_OutputState = TIM_OutputState_Enable;
    TIM_OCInitStructure.TIM_Pulse = CCR3_Val;
    TIM_OCInitStructure.TIM_OCPolarity = TIM_OCPolarity_High;
    TIM_OC3Init( TIM1, &TIM_OCInitStructure );

    NVIC_InitStructure.NVIC_IRQChannel = TIM1_CC_IRQn;
    NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 0;
    NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0;
    NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
    NVIC_Init(&NVIC_InitStructure);

	TIM_CtrlPWMOutputs(TIM1, ENABLE );
	TIM_OC1PreloadConfig( TIM1, TIM_OCPreload_Disable );
    TIM_OC2PreloadConfig( TIM1, TIM_OCPreload_Disable );
    TIM_OC3PreloadConfig( TIM1, TIM_OCPreload_Disable );
	TIM_ARRPreloadConfig( TIM1, ENABLE );
    TIM_ITConfig(TIM1,TIM_IT_CC1,ENABLE);
    TIM_ITConfig(TIM1,TIM_IT_CC2,ENABLE);
    TIM_ITConfig(TIM1,TIM_IT_CC3,ENABLE);
	TIM_Cmd( TIM1, ENABLE );
}

void TIM1_CC_IRQHandler(void)
{

    if(TIM_GetITStatus(TIM1,TIM_IT_CC1) == SET)
    {
        TIM_ClearFlag(TIM1,TIM_IT_CC1);
        capture = TIM_GetCapture1( TIM1 );//ȡ벶ȽϼĴ1ֵ
        if( flag1 == 0 )//ߵƽʱ
        {
            flag1 = 1;
            setcap = capture + ( u32 )CCR1_Val * CCR1_dc / 100;
        }
        else//͵ƽʱ
        {
            flag1 = 0;
            setcap = capture + ( u32 )CCR1_Val  * ( 100 - CCR1_dc ) / 100;
        }
        TIM_SetCompare1( TIM1, setcap  );
    }
    if(TIM_GetITStatus(TIM1,TIM_IT_CC2) == SET)
    {
        TIM_ClearFlag(TIM1,TIM_IT_CC2);
        capture = TIM_GetCapture2( TIM1 );
        if( flag2 == 0 )//ߵƽʱ
        {
            flag2 = 1;
            setcap = capture + CCR2_Val * CCR2_dc / 100;
        }
        else//͵ƽʱ
        {
            flag2 = 0;
            setcap = capture + CCR2_Val  * ( 100 - CCR2_dc ) / 100;
        }
        TIM_SetCompare2( TIM1, setcap );
    }
    if(TIM_GetITStatus(TIM1,TIM_IT_CC3) == SET)
    {
        TIM_ClearFlag(TIM1,TIM_IT_CC3);
        capture = TIM_GetCapture3( TIM1 );
        if( flag3 == 0 )//ߵƽʱ
        {
            flag3 = 1;
            setcap = capture + CCR3_Val * CCR3_dc / 100;
        }
        else//͵ƽʱ
        {
            flag3 = 0;
            setcap = capture + CCR3_Val  * ( 100 - CCR3_dc ) / 100;
        }
        TIM_SetCompare3( TIM1, setcap );
    }

}

int main(void)
{
    USART_Printf_Init(115200);
	TIM1_OutCompare_Init( 0xFFFF, 1-1);//Ƶ144MHz  ϼ455us
	while(1);
}
